using System;
using System.Web;
using System.Web.UI;
using System.Threading;
using System.Text;


public class Utils
{
    #region Debugging
    public static string ShowStackTrace()
    {
        string rawString = Environment.StackTrace.TrimEnd();
        string[] lines = rawString.Split(new string[] { "at " }, StringSplitOptions.RemoveEmptyEntries);
        string thread = Thread.CurrentThread.ManagedThreadId.ToString();
        
        StringBuilder sb = new StringBuilder(thread + "<ul>");

        foreach (string text in lines)
        {
            sb.AppendFormat("<li>{0}</li>", text);
        }

        sb.Append("</ul>");

        return sb.ToString();
    }

    public static void TraceThread()
    {
        string displayThread = "Thread=" + Thread.CurrentThread.ManagedThreadId.ToString();
        HttpContext.Current.Trace.Warn(displayThread, "");
    }

    public static void TraceThread(string msg)
    {
        string displayThread = "Thread=" + Thread.CurrentThread.ManagedThreadId.ToString();
        HttpContext.Current.Trace.Warn(displayThread, msg);
    }
    #endregion

    #region Browser
    public static bool IsIE()
    {
        HttpBrowserCapabilities caps = HttpContext.Current.Request.Browser;
        return caps.IsBrowser("IE");
    }

    public static bool IsMozilla()
    {
        HttpBrowserCapabilities caps = HttpContext.Current.Request.Browser;
        return caps.IsBrowser("mozilla");
    }
    #endregion
}
