<%@ WebHandler Language="C#" Class="DynImage" %>

using System;
using System.Web;
using System.Drawing;
using System.IO;
using System.Drawing.Imaging;




public class DynImage : IHttpHandler 
{
    public void ProcessRequest(HttpContext context)
    {
        // Process the URL param
        object o1 = context.Request["url"];
        if (o1 == null)
        {
            context.Response.Write("Kein Bild gefunden.");
            context.Response.End();
            return;
        }
        string file = context.Server.MapPath((string)o1);

        // Process the thumbnail param
        bool useThumbnail = false; 
        object o2 = context.Request["small"];
        if (o2 != null)
        {
            Boolean.TryParse((string) o2, out useThumbnail);
        }

        string msg = "Mit freundlicher Genehmigung von 'Programming Microsoft ASP.NET 2.0 Applications--Advanced Topics'";
        if (File.Exists(file))
        {
            Bitmap bmp = null;
            if (useThumbnail)
                bmp = GetThumbnail(file);
            else
                bmp = AddCopyright(file, msg);

            context.Response.ContentType = "image/jpeg";
            bmp.Save(context.Response.OutputStream, ImageFormat.Jpeg);
            bmp.Dispose();
        }
        else
        {
            context.Response.Write("Kein Bild gefunden.");
            context.Response.End();
        }
    }
     
    public bool IsReusable 
    {
        get 
        {
            return true;
        }
    }

    #region Helpers
    Bitmap GetThumbnail(string file)
    {
        Bitmap bmp = new Bitmap(file);
        Bitmap newImg = (Bitmap)bmp.GetThumbnailImage(
            bmp.Width / 3, bmp.Height / 3, null, IntPtr.Zero);
        return newImg;
    }
    
    Bitmap AddCopyright(string file, string msg)
    {
        // Load the file and create the graphics
        Bitmap bmp = new Bitmap(file);
        Graphics g = Graphics.FromImage(bmp);
        
        // Define text alignment
        StringFormat strFmt = new StringFormat();
        strFmt.Alignment = StringAlignment.Center;
        
        // Create brushes for the bottom writing
        // (green text on black background)
        SolidBrush btmForeColor = new SolidBrush(Color.PaleGreen);
        SolidBrush btmBackColor = new SolidBrush(Color.Black);
        
        // To calculate writing coordinates, obtain the size of the text
        // given font typeface and size
        Font btmFont = new Font("Verdana", 7);
        SizeF textSize = new SizeF();
        textSize = g.MeasureString(msg, btmFont);
        
        // Calculate the output rectangle and fill
        float x = ((float)bmp.Width - textSize.Width - 3);
        float y = ((float)bmp.Height - textSize.Height - 3);
        float w = ((float)x + textSize.Width);
        float h = ((float)y + textSize.Height);
        RectangleF textArea = new RectangleF(x, y, w, h);
        g.FillRectangle(btmBackColor, textArea);
        
        // Draw the text and free resources
        g.DrawString(msg, btmFont, btmForeColor, textArea);
        btmForeColor.Dispose();
        btmBackColor.Dispose();
        btmFont.Dispose();
        g.Dispose();
        
        return bmp;
    }
    #endregion
}