#region Using directives
using System;
using System.Configuration;
using System.Web;
using System.Web.UI;
using System.Data;
using System.Data.SqlClient;
using System.IO;
#endregion


namespace ProAspNet20.Advanced.CS.Components
{
    public class DbImageHandler : IHttpHandler
    {
        #region IHttpHandler 
		public void ProcessRequest(HttpContext context)
		{
            // Ensure the URL contains an ID argument being a number
            int id = -1;
            bool result = Int32.TryParse(context.Request.QueryString["id"], out id);
            if (!result)
            {
                context.Response.End();
            }

            string connString = ConfigurationManager.ConnectionStrings["LocalNWind"].ConnectionString;
            string cmdText = "SELECT photo FROM employees WHERE employeeid=@id";

            // Get an array of bytes from the BLOB field
            byte[] img = null;
            SqlConnection conn = new SqlConnection(connString);
            using (conn)
            {
                SqlCommand cmd = new SqlCommand(cmdText, conn);
                cmd.Parameters.AddWithValue("@id", id);
                conn.Open();
                img = (byte[])cmd.ExecuteScalar();
                conn.Close();
            }

            // Prepare the response for the browser
            if (img != null)
            {
                context.Response.ContentType = "image/jpeg";
//              context.Response.BinaryWrite(img,);

                // Das 78-byte-Offset ist augrund der besonderen (nicht
                // standardmigen) Struktur des Bildes notwendig, das
                // in der Employees-Tabelle der Northwind-Datenbank
                // gespeichert ist.
                context.Response.OutputStream.Write(img, 78, img.Length);
            }
		}

		public bool IsReusable
		{
			get { return true; }
        }
        #endregion



    }
}
