using System;
using System.Drawing;
using System.ComponentModel;
using ProAspNet20.Advanced.CS.Components.Design;


namespace ProAspNet20.Advanced.CS.Components
{
    // Indicates the filters available
    public enum GaugeFilterType
    {
        None,
        Glow,
        Alpha
    }

    [TypeConverter(typeof(GaugeFilterSettingsConverter))]
    public class FilterSettings
    {
        private GaugeFilterType _type;
        private Color _glowColor;
        private int _glowStrength;
        private int _alphaOpacity;

        public FilterSettings()
        {
            _type = GaugeFilterType.None;
            _glowStrength = 5;
            _alphaOpacity = 25;
        }

        [Description("Ruft den Typ des zu verwendenden Filters ab oder legt diesen fest")]
        [NotifyParentProperty(true)]
        public GaugeFilterType FilterType
        {
            get { return _type; }
            set { _type = value; }
        }

        [Description("Ruft die Rahmenfarbe ab oder legt diese fest")]
        [NotifyParentProperty(true)]
        public Color GlowColor
        {
            get { return _glowColor; }
            set { _glowColor = value; }
        }

        [Description("Gibt die Breite des Rahmens an")]
        [NotifyParentProperty(true)]
        public int GlowStrength
        {
            get { return _glowStrength; }
            set { _glowStrength = value; }
        }

        [Description("Gibt den Prozentsatz der gewnschten Deckkraft an")]
        [NotifyParentProperty(true)]
        public int AlphaOpacity
        {
            get { return _alphaOpacity; }
            set { _alphaOpacity = value; }
        }
    }

}