using System;
using System.Web;
using System.IO;



namespace ProAspNet20.Advanced.CS.Components
{
    public class MarkerModule : IHttpModule
    {
        #region Constants
        const string PageHeaderText = "<table width=100% style='font-family:verdana;font-size:8pt;' bgcolor=cyan><tr><td align=center>Sie mssen sich registrieren, um diese Website betrachten zu knnen! Klicken Sie <b><a href=http://www.contoso.com>hier</a>.</b></td></tr></table>";
        const string PageFooterText = "<table width=100% style='font-family:verdana;font-size:8pt;' bgcolor=cyan><tr><td align=center>Mit freundlicher Genehmigung von <b>Programming Microsoft ASP.NET 2.0Advanced Topics</b></td></tr></table>";
		#endregion


        #region IHttpModule
        public void Init(HttpApplication app)
        {
            // Register for pipeline events
            app.BeginRequest += new EventHandler(OnBeginRequest);
            app.EndRequest += new EventHandler(OnEndRequest);
        }

        public void Dispose()
        {
            // Nothing to do here
        }
        #endregion


        #region Helpers
        public void OnBeginRequest(object sender, EventArgs e)
        {
            HttpApplication app = (HttpApplication) sender;
            HttpContext ctx = app.Context;

		    // More code here

            // Add custom header to the HTTP response
            ctx.Response.AppendHeader("Author", "DinoE");
            ctx.Response.Write(PageHeaderText);
        }

        public void OnEndRequest(object sender, EventArgs e)
        {
            // Get access to the HTTP context 
            HttpApplication app = (HttpApplication) sender;
            HttpContext ctx = app.Context;

		    // More code here
        		

            // Append some custom text
            ctx.Response.Write(PageFooterText);
        }
        #endregion
    }
}

