#region Using directives
using System;
using System.Configuration;
using System.Web;
using System.Web.UI;
using System.Data;
using System.Data.SqlClient;
using System.IO;
#endregion


namespace ProAspNet20.Advanced.CS.Components
{
    public class MyBlobsImageHandler : IHttpHandler
    {
        #region IHttpHandler 
		public void ProcessRequest(HttpContext context)
		{
            // Ensure the URL contains an ID argument being a number
            int id = -1;
            bool result = Int32.TryParse(context.Request.QueryString["id"], out id);
            if (!result)
            {
                context.Response.End();
            }

            string connString = ConfigurationManager.ConnectionStrings["MyBlobs"].ConnectionString;
            string cmdText = "SELECT bits, mime FROM mypics WHERE imageid=@id";

            // Get an array of bytes from the BLOB field
            byte[] img = null;
            string mime = "";
            SqlConnection conn = new SqlConnection(connString);
            using (conn)
            {
                SqlCommand cmd = new SqlCommand(cmdText, conn);
                cmd.Parameters.AddWithValue("@id", id);
                conn.Open();
                SqlDataReader reader = cmd.ExecuteReader();
                reader.Read();
                img = (byte[])reader[0];
                mime = (string)reader[1];
                conn.Close();
            }

            // Prepare the response for the browser
            if (img != null)
            {
                context.Response.ContentType = mime;
                context.Response.BinaryWrite(img);
            }
		}

		public bool IsReusable
		{
			get { return true; }
        }
        #endregion

    }
}
