using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Data;
using System.Data.SqlClient;


namespace ProAspNet20.Advanced.CS.Components
{
    public class OrdersWebPart : WebPart 
    {
        // ************************************************************************
        // Private Members
        private int _empID;
        private DataTable _data = null;

        // ************************************************************************
        // Renders the UI of the control
        protected override void RenderContents (HtmlTextWriter writer)
        {
           if (_empID < 1)
           {
               writer.Write ("<span style='color:gray'>No employee is currently selected.</span>");
               return;
           }

            // Grab info and generate the UI
            FindEmployeeInfo();
            BuildUI (writer);
        }

        // ************************************************************************
        // Function called when this connection is established
		// define the call back method that get the object of type IEmployeeInfo
		[ConnectionConsumer("EmployeeIDConsumer", "EmployeeIDConsumer")]
		public void GetEmployeeInfo(IEmployeeInfo empInfo)
		{
			if (empInfo != null)
			{
				_empID = empInfo.EmployeeID;
				FindEmployeeInfo();
			}
			else
			{
				throw new NotSupportedException("No connection data found.");
			}
		}

        // ************************************************************************
        // Retrieves employee information
        private void FindEmployeeInfo()
        {
            if (_empID <1)
               return;

            SqlDataAdapter adapter;
            adapter = new SqlDataAdapter(
                "SELECT orderid, customerid, employeeid, orderdate FROM orders WHERE employeeid=" + _empID.ToString() + " AND year(orderdate)=1997", 
                "SERVER=(local);DATABASE=northwind;Trusted_Connection=Yes");
            _data = new DataTable();

            adapter.Fill(_data);
		}

        // ************************************************************************
        // Build the Web part's UI
        private void BuildUI (HtmlTextWriter writer)
        {
            DataGrid _grid = new DataGrid ();
            _grid.AutoGenerateColumns = true;
			_grid.Font.Name = "verdana";
            _grid.Font.Size = FontUnit.Point(8);
            _grid.HeaderStyle.Font.Bold = true;
            _grid.DataSource = _data;
            _grid.DataBind();
            _grid.RenderControl(writer);
        }
	}
}

