using System;
using System.CodeDom;
using System.Web.Compilation;
using System.Web;
using System.Web.UI;
using System.ComponentModel;
using System.Drawing;



namespace ProAspNet20.Advanced.CS.Components
{
    //[ExpressionEditor("ProfileExpressionEditor")]
    [ExpressionPrefix("Profile")]
    public class ProfileExpressionBuilder : ExpressionBuilder
    {
        public static object GetProperty(string propName, Type t)
        {
            object value = HttpContext.Current.Profile.GetPropertyValue(propName);

           // System.Windows.Forms.MessageBox.Show(t.ToString(), propName);

            if (value is string)
            {
               // System.Windows.Forms.MessageBox.Show((t == typeof(Color)).ToString(), t.ToString());
                if (t == typeof(Color))
                {
                //   System.Windows.Forms.MessageBox.Show("value.ToString()", propName);
                   ColorConverter cc = new ColorConverter();
                   Color c = (Color) cc.ConvertFrom(value);
                   return c;
                }
            }
            return value;
        }

        public override object EvaluateExpression(
            object target, BoundPropertyEntry entry, object parsedData, ExpressionBuilderContext context)
        {
            // "parsedData" gets what ParseExpression returns
            string propName = (string)parsedData;
            return GetProperty(propName, entry.Type);
        }

        public override CodeExpression GetCodeExpression(
            BoundPropertyEntry entry, object parsedData, ExpressionBuilderContext context)
        {
            // Grab the name of the profile property
            string property = (string) parsedData;

            // Must generate code for the right-side part of an assignment.
            // We make it call into a static method of this class.

            // Define the CodeDOM object that represents the 
            // parameter of the static tmethod
            CodePrimitiveExpression prim = new CodePrimitiveExpression(property);
            CodeTypeOfExpression t = null;
            if (entry.Type != null)
                t = new CodeTypeOfExpression(entry.Type);
            else
                t = new CodeTypeOfExpression("System.Object");

            CodeExpression[] args = new CodeExpression[2] { prim, t };

            // Define the CodeDOM object to represent the method invocation
            CodeTypeReferenceExpression refType;
            refType = new CodeTypeReferenceExpression(base.GetType());
            return new CodeMethodInvokeExpression(refType, "GetProperty", args); 
        }


        public override bool SupportsEvaluate
        {
            get { return true; }
        }

        public override object ParseExpression(string expression, Type propertyType, ExpressionBuilderContext context)
        {
            // We assume a syntax <%$ Profile:PropName %>

            // Expression evaluates to "PropName"
            // No need to parse more

            return expression;
        }
    }
}
