using System;
using System.Data;
using System.Data.SqlClient;
using System.Text;

namespace ProAspNet20.Advanced.CS.Components
{
    #region Class ChartDataProvider
    public abstract class ChartDataProvider
    {
        public abstract DataTable GetData();
        public abstract string DataLabelField { get; }

        public abstract string DataField { get; }
    }
    #endregion


    #region Class SalesChartDataProvider
    public class SalesChartDataProvider : ChartDataProvider
    {
        public SalesChartDataProvider()
        {
        }

        public override string DataLabelField
        {
            get { return "Employee"; }
        }

        public override string DataField
        {
            get { return "Sales"; }
        }

        public override DataTable GetData()
        {
            DataTable data = new DataTable();

            // Get the up-to-date information
            StringBuilder sb = new StringBuilder("");
            sb.Append("SELECT e.lastname AS Employee, SUM(price) AS Sales FROM ");
            sb.Append("(SELECT o.employeeid, od.orderid, SUM(od.quantity*od.unitprice) AS price ");
            sb.Append("    FROM Orders o, [Order Details] od");
            sb.Append("    WHERE Year(o.orderdate) = {0} AND od.orderid=o.orderid ");
            sb.Append("		GROUP BY o.employeeid, od.orderid ) AS t1 ");
            sb.Append("INNER JOIN Employees e ON t1.employeeid=e.employeeid ");
            sb.Append("GROUP BY t1.employeeid, e.lastname");

            string selectCmd = sb.ToString();
            selectCmd = String.Format(selectCmd, 1998);
            string connString = "SERVER=.;DATABASE=northwind;Trusted_Connection=Yes";

            SqlDataAdapter adapter = new SqlDataAdapter(selectCmd, connString);
            adapter.Fill(data);

            return data;
        }
    }
    #endregion
}
