using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;


namespace ProAspNet20.Advanced.CS.Components
{
    public class SimpleHyperLinkList : ListControl 
    {
	    #region Private members
	    // ***************************************************************************************************
	    // Private members
	    private HyperLink _controlToRepeat;
	    #endregion


	    #region Properties
	    // ***************************************************************************************************
	    // PROPERTY (PRIVATE) ControlToRepeat 
	    // Represent the tree of controls to repeat in the final list
	    private HyperLink ControlToRepeat
	    {
		    get
		    {
			    if (_controlToRepeat == null)
				    _controlToRepeat = new HyperLink();
			    return _controlToRepeat;
		    }
	    }
	    #endregion


	    #region Overridden Methods
	    // ***************************************************************************************************
	    // METHOD Render 
	    // Generates the markup for the control
	    protected override void Render(HtmlTextWriter writer)
	    {
           for(int i=0; i<Items.Count; i++)
           {
               HyperLink ctl = ControlToRepeat;
               ctl.ApplyStyle(ControlStyle);
               ctl.ID = i.ToString();
               ctl.Text = Items[i].Text;
               ctl.NavigateUrl = Items[i].Text;
               ctl.ToolTip = Items[i].Value;
               ctl.RenderControl(writer);
               writer.Write("<br />");
           }
	    }
	    #endregion
    }
}
