using System;
using System.ComponentModel;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;


namespace ProAspNet20.Advanced.CS.Components
{
	public class BookFinderWebPart : WebPart
	{
		// No-op implementation
	}

	public class SportChannelWebPart : WebPart
	{
		// No-op implementation
	}

	public class WeatherWebPart : WebPart 
    {
        #region Private Members

		// The Zip code parameter
		private string _zipCode = "";

		// Dynamic script code to add to the Web part
        private const string HtmlFormat = @"
            <div id=""weatherView""></div>
            <script id=""weatherScript"" language=""javascript""></script>
            <script language=""javascript"">
            function CreateWeather(sAcid) {{
            	var oData = window['weatherScript'];
            	if (sAcid != '') {{
            		oData.onreadystatechange = ShowWeather;
            		oData.src = 'http://www.msnbc.com/m/chnk/d/weather_d_src.asp?acid=' + sAcid;
            	}}
            }}
            
            function ShowWeather() {{

                if (typeof(makeWeatherObj) != 'undefined') {{
                                var oWea = new makeWeatherObj();
                var sTmp = '<b>Current Weather Conditions</b><hr size=1>' +
                           '<table cellpadding=2 cellspacing=0 border=0><tr><td valign=""middle"">' +
                           '<img src=""http://www.msnbc.com/m/wea/i/36/' + oWea.swCIcon + '.gif"" align=absmiddle></td>' +
                           '<td>'+ oWea.swCity + ', ' + oWea.swSubDiv + '<br>' +
                           + oWea.swTemp + '&#176;F</td></tr></table>' + 
                           '<a href=""http://www.weather.com"">More weather information</a>';
            	document.all['weatherView'].innerHTML = sTmp;
                }}
            }}
            
            CreateWeather('{0}');
            </script>
            ";  
        #endregion

		// ************************************************************************
		// Gets and sets the zip code to populate the part
		[Personalizable]
		[WebBrowsable]
		public string ZipCode 
		{
			get {return _zipCode;}
			set {_zipCode = value;}
		}


		// ************************************************************************
       // Gets and sets the Web part collection of connection points
       protected override void RenderContents (HtmlTextWriter writer)
       {
			if ((_zipCode == null) || (_zipCode.Length == 0)) 
				writer.Write("Select a zip code by personalizing this WebPart");
           else {
					writer.Write(String.Format(HtmlFormat, _zipCode));
					writer.Write("&nbsp;");
			}
		}
    }
}

