using System;
using System.Collections;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Reflection;
using System.Text;
using System.IO;


public partial class ShowRuntimeInfo : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void OnShowInfo(object sender, EventArgs e)
    {
        DisplayRuntimeInfo();
    }
    private void DisplayRuntimeInfo()
    {
        StringBuilder sb = new StringBuilder("");

        // Prepare the table to output
        sb.Append("<table width=100%>");

        // Display some properties from the HttpRuntime object
        sb.Append("<tr><td><b>AppDomainAppId</b></td><td>");
        sb.Append(HttpRuntime.AppDomainAppId);
        sb.Append("</td></tr>");

        sb.Append("<tr><td><b>AppDomainAppPath</b></td><td>");
        sb.Append(HttpRuntime.AppDomainAppPath);
        sb.Append("</td></tr>");

        sb.Append("<tr><td><b>AppDomainAppVirtualPath</b></td><td>");
        sb.Append(HttpRuntime.AppDomainAppVirtualPath);
        sb.Append("</td></tr>");

        sb.Append("<tr><td><b>AppDomainId</b></td><td>");
        sb.Append(HttpRuntime.AppDomainId);
        sb.Append("</td></tr>");

        sb.Append("<tr><td><b>Temporres ASP.NET-Verzeichnis</b></td><td>");
        sb.Append(HttpRuntime.CodegenDir);
        sb.Append("</td></tr>");

        Assembly[] listOfAssem = AppDomain.CurrentDomain.GetAssemblies();
        sb.Append("<tr><td valign=top><b>Assemblies in der AppDomain</b> (");
        sb.Append(listOfAssem.Length.ToString());
        sb.Append(")</td><td>");

        // Sort assembly names
        ArrayList list = new ArrayList();
        foreach (Assembly a in listOfAssem)
        {
            try
            {
                list.Add(Path.GetFileName(a.Location));
            }
            catch
            {
            }
        }
        list.Sort();

        // Render assemblies
        sb.Append("<ul>");
        foreach (object asm in list)
        {
            sb.Append("<li>");
            sb.Append((string)asm);
            sb.Append("</li>");
        }

        sb.Append("</ul>");
        sb.Append("</td></tr></table>");


        TheRuntimeInfo.Text = sb.ToString();
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        HttpRuntime.UnloadAppDomain();
        DisplayRuntimeInfo();
    }
}
