using System;
using System.Data;
using System.Web.Configuration;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using ProAspNet20.Advanced.CS.Components; 


public partial class Samples_Ch03_Managing_MyPages : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string path = Request.ApplicationPath;
        Configuration config = WebConfigurationManager.OpenWebConfiguration(path);
        MyPagesSection section = (MyPagesSection)config.GetSection("myPages");
        if (section == null)
            return;

        // Find the server <body> tag if any
        HtmlControl body = LookupForBody();
        if (body != null)
            body.Attributes["bgcolor"] = section.PageBackColor;
    }

    private HtmlControl LookupForBody()
    {
        HtmlGenericControl body = null;

        // Scroll all page controls to locate a HTML tag with the name of "body"
        foreach (Control ctl in Controls)
        {
            if (ctl is HtmlControl)
            {
                HtmlControl htmlCtl = (HtmlControl)ctl;
                if (htmlCtl.TagName.ToLower() == "body")
                {
                    body = (HtmlGenericControl)htmlCtl;
                    return body;
                }
            }
        }
        return body;
    }
}
