using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Threading;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;



public partial class DbAsync : System.Web.UI.Page
{
    private const string SPROC_NAME = "SalesByCategory"; //"Employee Sales by Country"; 
    private const string ConnString = "LocalNWind";
    private SqlCommand cmd;
    private SqlConnection conn;


    void Page_Load (object sender, EventArgs e)
    {
        AddOnPreRenderCompleteAsync (
            new BeginEventHandler(BeginTask),
            new EndEventHandler(EndTask));
    }

    IAsyncResult BeginTask(object sender, EventArgs e, AsyncCallback cb, object state)
    {
        // Trace 
        Utils.TraceThread("BeginTask, Anfang");

        // Prepare to execute an async command 
        string cs = ConfigurationManager.ConnectionStrings[ConnString].ConnectionString + ";Asynchronous Processing=true;";
        conn = new SqlConnection(cs);

        // Fire the first command: get customer info
        cmd = new SqlCommand(SPROC_NAME, conn);
        cmd.CommandType = CommandType.StoredProcedure;
        cmd.Parameters.Add("@CategoryName", SqlDbType.NVarChar, 15).Value = "Seafood";
        cmd.Parameters.Add("@OrdYear", SqlDbType.Int).Value = 1997;
        
        // Fire the command
        conn.Open();
        IAsyncResult ar = cmd.BeginExecuteReader(cb, state);
        Utils.TraceThread("Befehl gestartet");

        // Trace
        Utils.TraceThread("BeginTask, Ende");
        Utils.TraceThread();
        return ar;
    }

    void EndTask(IAsyncResult ar)
    {
        // This code will be called on a pooled thread.
        // HttpContext.Current is NULL by design. For this reason, we
        // can't use Utils.TraceThread...

        SqlDataReader reader;

        // Trace 
        string displayThread = "Thread=" + Thread.CurrentThread.ManagedThreadId.ToString();
        Trace.Warn(displayThread, "EndTask, Anfang");


        reader = cmd.EndExecuteReader(ar);
        Trace.Warn(displayThread, "Reader wurde abgerufen; Jetzt erfolgt die Bindung...");
        if (!reader.Read())
             return;

        GridView1.DataSource = reader;
        GridView1.DataBind();
        reader.Close();
        conn.Close();
        
        // Trace
        Trace.Warn(displayThread, "EndTask, Ende");
    }
}


