using System;
using System.Configuration;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text;

using System.Reflection;
using System.IO;


public partial class PopupPage : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		string URL = "http://weblogs.asp.net/despos";

		// Register needed script code
		Type t = this.GetType();
		if (!Page.ClientScript.IsClientScriptBlockRegistered(t, "ShowPopup"))
		{
			// Configure the button
			PopupButton.Attributes["onclick"] = "ShowPopup()";
			PopupButton.Disabled = false;

			// Compose and register the script 
			RegisterPopupWindow(t, "ShowPopup", URL, true);
		}
        else
            PopupButton.Disabled = true;
	}

	#region Popup Windows API
	public void RegisterPopupWindow(Type t, string functionName, string targetUrl)
	{
		RegisterPopupWindow(t, functionName, targetUrl, true, "", true);
	}

	public void RegisterPopupWindow(Type t, string functionName, string targetUrl, bool modal)
	{
		RegisterPopupWindow(t, functionName, targetUrl, modal, "", true);
	}

	public void RegisterPopupWindow(Type t, string functionName, string targetUrl, bool modal, string style, bool addScriptTag)
	{
		string js = BuildScriptCode(targetUrl, functionName, modal, style);
		if (!ClientScript.IsClientScriptBlockRegistered(functionName))
		{
			ClientScript.RegisterClientScriptBlock(t, functionName, js, addScriptTag);
		}
	}

    private string BuildScriptCode(string url, string functionName, bool modal, string style)
    {
        StringBuilder sb = new StringBuilder();
		sb.AppendFormat("function {0}()", functionName);
		sb.AppendLine(" {");
        sb.AppendLine("  if (document.all) {");
		sb.AppendFormat("     window.{0}(\"{1}\", \"{2}\", \"{3}\");",
			(modal ?"showModalDialog" :"showModelessDialog"),
			url,
			"",
			style);
        sb.AppendLine();
        sb.AppendLine("  } else {");
        sb.AppendFormat("     window.open(\"{0}\", '', \"{1}\");", url, style);
        sb.AppendLine("}");
		sb.AppendLine("}");

        return sb.ToString();
	}
	#endregion
}
