using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;


public partial class OrderViewer : System.Web.UI.Page, ICallbackEventHandler
{
    protected void Page_Load(object source, EventArgs e)
    {
        string rpc = ClientScript.GetCallbackEventReference(this, 
			"arg", "UpdateOrders", "null", "ShowError", false);
        
		string func = "function ShowOrders(arg) { " + rpc + "; }";
        ClientScript.RegisterClientScriptBlock(this.GetType(), "ShowOrders", func, true);
    }

    #region ICallbackEventHandler
    private string _results;
    void ICallbackEventHandler.RaiseCallbackEvent(string eventArgument)
    {
		int empID = -1;
		bool success = Int32.TryParse(eventArgument, out empID);

		SqlConnection conn = null; 
		StringBuilder sb = new StringBuilder();
		using (conn = new SqlConnection(ConfigurationManager.ConnectionStrings["LocalNWind"].ConnectionString))
		{
			SqlCommand cmd = new SqlCommand("SELECT orderid FROM orders WHERE employeeid=@id AND year(orderdate) = 1997", conn);
			cmd.Parameters.AddWithValue("@id", empID);
			conn.Open();
			SqlDataReader reader = cmd.ExecuteReader();
			while (reader.Read())
			{
				sb.AppendFormat("{0},", reader[0]);
			}
			reader.Close();
			conn.Close();
		}

		string data = sb.ToString();
		char[] charsToTrim = {','};
        _results = data.Trim(charsToTrim);
        return;
    }
    string ICallbackEventHandler.GetCallbackResult()
    {
        return _results;
    }
    #endregion

}
