using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Web.Mobile;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.MobileControls;
using System.Web.UI.WebControls;
using System.Configuration;


public partial class CustomerFinder : System.Web.UI.MobileControls.MobilePage
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void FindButton_Click(object sender, EventArgs e)
    {
        DoSelectCustomers(CustInitials.Text);
    }

    protected void Menu_ItemCommand(object sender, ListCommandEventArgs e)
    {
        string[] menuItems = e.ListItem.Value.Split(",".ToCharArray());
        Session["AvailableInitials"] = menuItems;
        LetterList.DataSource = menuItems;
        LetterList.DataBind();

        ActiveForm = SecondMenuForm;
    }

    protected void LetterList_ItemCommand(object sender, ListCommandEventArgs e)
    {
        DoSelectCustomers(e.ListItem.Value);
    }

    protected void FindCustomerButton_Click(object sender, EventArgs e)
    {
        DoSelectCustomers(CustName.Text);
    }

    private void DoSelectCustomers(string patternOfName)
    {
        DataView view = SelectCustomers(patternOfName);
        CustomerList.DataSource = view;
        CustomerList.DataBind();

        ActiveForm = CustomerForm;
    }



    #region Data Access
    private DataView SelectCustomers(string filterString)
    {
        // Get data
        DataTable data = GetData();
        DataView view = new DataView(data);

        // Apply a filter
        string cmdText = "";
        string[] initials = filterString.Split(",".ToCharArray());

        string opOR = "";
        foreach (string s in initials)
        {
            cmdText += String.Format("{0} {2} LIKE '{1}%' ", opOR, s, "companyname");
            opOR = " OR ";
        }

        // Return data
        view.RowFilter = cmdText;
        return view;
    }

    private DataTable GetData()
    {
        DataSet ds = (DataSet)Cache["Customers"];
        if (ds == null)
        {
            ds = LoadDataFromDatabase();
            Cache["Customers"] = ds;
        }
        return ds.Tables[0];
    }

    private DataSet LoadDataFromDatabase()
    {
        string QueryCustomers = "SELECT customerid,companyname,address,city,country,phone FROM customers";
        string connString = ConfigurationManager.ConnectionStrings["LocalNWind"].ConnectionString;
        DataSet data = new DataSet();
        SqlDataAdapter adapter = new SqlDataAdapter(QueryCustomers, connString);
        adapter.Fill(data, "Customers");
        return data;
    }
    #endregion
}
