using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;


public partial class Samples_Ch09_DbImages_UploadPics : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        int sizeOfFile = theFile.PostedFile.ContentLength;
        int recordsAffected = -1;

        // Prepare for the SQL command
        string connString = ConfigurationManager.ConnectionStrings["MyBlobs"].ConnectionString;
        SqlConnection conn = new SqlConnection(connString);
        using (conn)
        {
            string cmdText = "INSERT INTO MyPics " +
                   "(bits, description, uploader, uploadtime, imagesize, mime) " +
                   "VALUES (@imageBits, @description, @uploader, @uploadTime, " +
                   "@imageSize, @mimeType)";
            SqlCommand cmd = new SqlCommand(cmdText, conn);

            // Set parameters
            cmd.Parameters.AddWithValue("@imageBits",
                GetImageBits(theFile.PostedFile.InputStream, sizeOfFile));
            cmd.Parameters.AddWithValue("@description", theDesc.Text);
            cmd.Parameters.AddWithValue("@uploader", theUploader.SelectedItem.Value);
            cmd.Parameters.AddWithValue("@uploadTime", DateTime.Now);
            cmd.Parameters.AddWithValue("@imageSize", sizeOfFile);
            cmd.Parameters.AddWithValue("@mimeType", theFile.PostedFile.ContentType);

            // Copy the bits into the table
            conn.Open();
            recordsAffected = cmd.ExecuteNonQuery();
            conn.Close();
        }

        // Feedback to users
        string msg = (recordsAffected != -1 ? "Erfolgreich beendet!" : "Ein Fehler trat auf...");
        string js = String.Format("alert('{0}');", msg);
        ClientScript.RegisterStartupScript(this.GetType(), "Alert", js, true);

        DropDownList2.DataBind();
        return;
    }

    private byte[] GetImageBits(Stream fs, int size)
    {
        byte[] img = new byte[size];
        fs.Read(img, 0, size);
        return img;
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        string url = String.Format("myblobs.axd?id={0}", DropDownList2.SelectedValue);
        Image1.ImageUrl = url;
    }
}
