using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Collections;



public partial class CustomerList : System.Web.UI.Page
{
    protected CheckBox m_checkBox;
    private string m_connString = "SERVER=localhost;DATABASE=Northwind;Trusted_Connection=Yes";
    private string m_cmdCustmrs = "SELECT * FROM customers WHERE companyname LIKE '{0}%'";
    private string m_cmdInitial = "SELECT DISTINCT substring(companyname, 1, 1) AS Initial FROM customers";
    
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
            BindInitials();
    }

    private void BindInitials()
    {
        DataSet _data = new DataSet();

        // Get the initials
        SqlDataAdapter _adapter = new SqlDataAdapter(m_cmdInitial, m_connString);
        _adapter.Fill(_data, "Initials");

        Picker.DataSource = _data.Tables["Initials"].DefaultView;
        Picker.DataBind();
    }

    protected Color GetBackColor(object dataItem)
    {
        string _initial = (string)DataBinder.GetPropertyValue(dataItem, "Initial");
        if (_initial == (string)ViewState["Initial"])
            return Color.Gray;
        return Color.LightCyan;
    }

    protected Color GetForeColor(object dataItem)
    {
        string _initial = (string)DataBinder.GetPropertyValue(dataItem, "Initial");
        if (_initial == (string)ViewState["Initial"])
            return Color.White;
        return Color.Black;
    }

    protected void ItemCommand(object sender, DataListCommandEventArgs e)
    {
        BindData(e.CommandName);
    }

    private void BindData()
    {
        BindData((string)ViewState["Initial"]);
    }

    private void BindData(string initial)
    {
        // Store the initial
        ViewState["Initial"] = initial;

        // Get the data
        string _cmdText = m_cmdInitial + ";";
        _cmdText += String.Format(m_cmdCustmrs, initial);
        SqlDataAdapter _adapter = new SqlDataAdapter(_cmdText, m_connString);
        DataSet _data = new DataSet();
        _adapter.Fill(_data);

        // Rename tables
        _data.Tables[0].TableName = "Initials";
        _data.Tables[1].TableName = "Customers";

        // Reset selected and edit items
        Customers.SelectedIndex = -1;
        Customers.EditItemIndex = -1;

        Picker.DataSource = _data.Tables["Initials"].DefaultView;
        Picker.DataBind();
        Customers.DataSource = _data.Tables["Customers"].DefaultView;
        Customers.DataBind();
    }

    protected string SetHeader()
    {
        string _text = "Customers [{0}]";
        return String.Format(_text, (string)ViewState["Initial"]);
    }

    protected string SetFooter()
    {
        string _text = "{0} Kunde(n) gefunden.";

        ICollection _coll = (ICollection)Customers.DataSource;
        return String.Format(_text, _coll.Count);
    }

    protected string SetCustomerName(object dataItem)
    {
        string _output = "<b>{0}&nbsp;-&nbsp;{1}</b>";
        _output = String.Format(_output, 
            DataBinder.GetPropertyValue(dataItem, "customerid"), 
            DataBinder.GetPropertyValue(dataItem, "companyname"));

        return _output;
    }

    protected string ShowInfoBar(object dataItem)
    {
        string color = (m_checkBox.Checked ? "blue" : "black");
        string _output = "<span style='color:{0};'>(<i>{1}, {2}</i>)</span>";
        _output = String.Format(_output, color, 
            DataBinder.GetPropertyValue(dataItem, "contactname"), 
            DataBinder.GetPropertyValue(dataItem, "contacttitle"));

        return _output;
    }

    protected string ShowAddressBar(object dataItem)
    {
        if (!m_checkBox.Checked)
            return "";

        string color = (m_checkBox.Checked ? "blue" : "black");
        string _output = "<br><span style='color:{0};'>{1}, {2} ({3})<br>{4}</span>";
        _output = String.Format(_output, color, 
            DataBinder.GetPropertyValue(dataItem, "address"), 
            DataBinder.GetPropertyValue(dataItem, "city"), 
            DataBinder.GetPropertyValue(dataItem, "country"), 
            DataBinder.GetPropertyValue(dataItem, "Phone"));

        return _output;
    }


    protected CheckBox FindCheckBox(Control container)
    {
        CheckBox ctl = (CheckBox)container.FindControl("ExpandButton");
        if (ctl == null)
            return null;

        // Must anticipate the state restoration here. When this function executes we're
        // in the middle of the DataBind call on the given RepeaterItem object and 
        // before the ItemDataBound event fires. At this time, the Checked property of the 
        // CheckBox (as well as the Text property of a TextBox) has not been updated yet.
        ctl.Checked = (Page.Request.Form[ctl.UniqueID] == "on");

        return ctl;
    }

    public void OnRefresh(object sender, EventArgs e)
    {
        BindData();
    }
}
