using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections;
using System.Web;
using System.Configuration;
using System.Web.UI;
using System.Web.UI.WebControls;
using ProAspNet20.Advanced.CS.Components;


public partial class TestButtonList : System.Web.UI.Page
{
    private string m_cmdInitial = "SELECT DISTINCT substring(companyname, 1, 1) AS Initial FROM customers";
    private string m_cmdYears = "SELECT DISTINCT year(orderdate) AS year FROM orders";
    private string m_connString; 

    protected void Page_Load(object sender, EventArgs e)
    {
        m_connString = ConfigurationManager.ConnectionStrings["LocalNWind"].ConnectionString;
        if (!IsPostBack)
        {
            BindInitials();
            BindYears();
        }
    }


    private void BindInitials()
    {
        DataTable data = GetData_Initials();
        initialStrip.DataSource = data;
        initialStrip.DataTextField = "Initial";
        initialStrip.DataValueField = "Initial";
        initialStrip.DataBind();
    }

    private void BindYears()
    {
        DataTable data = GetData_Years();
        yearStrip.DataSource = data;
        yearStrip.DataTextField = "Year";
        yearStrip.DataValueField = "Year";
        yearStrip.DataBind();
    }

    private DataTable GetData_Years()
    {
        DataTable data = new DataTable();
        SqlDataAdapter adapter = new SqlDataAdapter(m_cmdYears, m_connString);
        adapter.Fill(data);
        return data;
    }

    private DataTable GetData_Initials()
    {
        DataTable data = new DataTable();
        SqlDataAdapter adapter = new SqlDataAdapter(m_cmdInitial, m_connString);
        adapter.Fill(data);
        return data;
    }

    protected void ButtonClicked(object sender, ButtonClickedEventArgs e)
    {
        if (sender.Equals(initialStrip))
            msg1.Text = String.Format("Kundennamen, die der <b>{0}.</b> Registerkarte namens <b>'{1}'</b> zugeordnet sind.",
                            1 + e.ButtonIndex, e.ButtonCommand);
        else
            msg2.Text = String.Format("Bestellinformationen, die der <b>{0}.</b> Registerkarte namens <b>'{1}'</b> zugeordnet sind.",
                            1 + e.ButtonIndex, e.ButtonCommand);
   }

   protected void RefreshData(object sender, RefreshDataEventArgs e)
   {
       if (sender.Equals(initialStrip))
           e.DataSource = GetData_Initials();
       else
           e.DataSource = GetData_Years();
   }
}
