using System;
using System.Data;
using System.Text;
using System.Collections;
using System.Web;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;


public partial class Samples_Ch14_BarChart_TestBarChart : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        DataTable data = ExecuteQuery(1997);
        BarChart1.Maximum = 150000;
        BarChart1.DataValueFormatString = "<span style=font-size:smaller>{0:c}</span>";
        BarChart1.Title = "Northwind-Verkufe";
        BarChart1.SubTitle = "(Jahr 1997)";
        BarChart1.DataSource = data;
        BarChart1.DataTextField = "Employee";
        BarChart1.DataValueField = "Sales";
        BarChart1.DataBind(); 
    }

    // ***************************************************************************
    // Fetch the data
    private const string m_connectionString = "DATABASE=northwind;SERVER=localhost;Trusted_Connection=Yes";
    private DataTable ExecuteQuery(int theYear)
    {
        // Prepare the connection object
        SqlConnection conn = new SqlConnection(m_connectionString);

        /*  
           SELECT e.lastname AS Employee, SUM(price) AS Sales FROM
           (SELECT o.employeeid, od.orderid, SUM(od.quantity*od.unitprice) AS price FROM Orders o, [Order Details] od
            WHERE Year(o.orderdate)=@TheYear AND od.orderid=o.orderid
            GROUP BY o.employeeid, od.orderid ) AS t1 
            INNER JOIN Employees e ON t1.employeeid=e.employeeid
            GROUP BY t1.employeeid, e.lastname
        */

        // Prepare the SELECT command object
        StringBuilder sb = new StringBuilder("");
        sb.Append("SELECT e.lastname AS Employee, SUM(price) AS Sales FROM ");
        sb.Append("(SELECT o.employeeid, od.orderid, SUM(od.quantity*od.unitprice) AS price ");
        sb.Append("    FROM Orders o, [Order Details] od");
        sb.Append("    WHERE Year(o.orderdate)=@TheYear AND od.orderid=o.orderid ");
        sb.Append("	GROUP BY o.employeeid, od.orderid ) AS t1 ");
        sb.Append("INNER JOIN Employees e ON t1.employeeid=e.employeeid ");
        sb.Append("GROUP BY t1.employeeid, e.lastname");

        SqlCommand cmd = new SqlCommand(sb.ToString(), conn);

        // Add the needed parameters
        SqlParameter p1 = new SqlParameter();
        p1.ParameterName = "@TheYear";
        p1.SqlDbType = SqlDbType.Int;
        p1.Direction = ParameterDirection.Input;
        p1.Value = theYear;
        cmd.Parameters.Add(p1);

        // Prepare the Data Adapter
        SqlDataAdapter da = new SqlDataAdapter();
        da.SelectCommand = cmd;
        DataTable dt = new DataTable("NorthwindSales");
        da.Fill(dt);

        return dt;
    }
    protected void BarChart1_BarChartDataBound(object sender, ProAspNet20.Advanced.CS.Components.BarChartItemEventArgs e)
    {
        Decimal d = (Decimal) DataBinder.GetPropertyValue(e.Item.DataItem, "sales");
        string tip = d.ToString();
        e.Item.Attributes["title"] = tip;
        if (d > 70000)
            e.Item.Cells[1].BackColor = Color.LightGreen;
    }
}
