using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.WebControls;


public partial class Samples_Ch14_Single_TestGaugeBound : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            // This value is persisted across postbacks because we save TextStyle
            // in the viewstate
            GaugeBar1.TextStyle.BackColor = Color.Yellow;
        }

        // Uses a random number as the value of the GaugeBar. 
        // The value is stored in a DataTable object
        Random rnd = new Random();
        DataTable dt = new DataTable();
        dt.Columns.Add("Numbers", typeof(float));
        dt.Columns.Add("Label", typeof(string));
        DataRow row = dt.NewRow();
        row[0] = rnd.Next(0, 100);
        row[1] = "{0} out of {1}";
        dt.Rows.Add(row);
        dt.AcceptChanges();

        // Binds the DataTable to the GaugeBar
        GaugeBar1.DataValueField = "numbers";
        GaugeBar1.DataTextField = "label";
        GaugeBar1.DataSource = dt;
        GaugeBar1.DataBind();

        /*
        GaugeBar1.DataItem.Text = "{0}%";
        GaugeBar1.DataItem.Value = 12;
        */
    }
}
